function filterFormsSelect(){
		
		// List ID Selected 
		var listOptionValue = jQuery("#newsletter_list option:selected").val();
	
		// Iterate all options of the AC form select
		jQuery("#newsletter_list_forms > option").each(function() {
						
			var currentOptionValue = this.value;
			if( currentOptionValue == "" ){
				return;
			}
			
			var formOptionValueArray = currentOptionValue.split('-');
						
			// It could be only one ID or a list of IDs separated by commas
			var listOfAcListsIDs = formOptionValueArray[1];
			
			var listOfAcListsIDsArray = listOfAcListsIDs.split(',');
		
			//Reset all visibility for all options
			jQuery('#newsletter_list_forms option[value="'+ currentOptionValue + '"]').show();
			if( jQuery.inArray( listOptionValue, listOfAcListsIDsArray ) == -1 ){
				jQuery('#newsletter_list_forms option[value="'+ currentOptionValue + '"]').hide();
			}
		});
			
}


function filterListsSelect(){
		
		var listOptionSelected = jQuery("#newsletter_list option:selected");
		
		if( listOptionSelected.val() == ""){
			listOptionSelected.val("0");
		}
		
			
		jQuery("#newsletter_list > option").each(function() {
						
			var currentOptionValue = this.value;
			if( currentOptionValue == "" ){
				jQuery('#newsletter_list option[value=""]').hide();
			}
		});
		
		//jQuery("#newsletter_list").trigger( 'change' );
}

function clearFieldsMappingValues(){	
	var listOptionSelected = jQuery("#newsletter_list option:selected");
		
	if( listOptionSelected.val() == "0" ){
		jQuery(".nf-field-sub-settings").empty().trigger( 'change' );
	}
}

jQuery(document).ready(function($){
	
	$('#nf-builder').on('change', 'select#newsletter_list', function() {

		// First clean up the hidden field and the form selected option
		$('#ACfields_hidden_form_id').val( "" ).trigger( 'change' );
		$("#newsletter_list_forms option").prop("selected", false).trigger( 'change' );
		$("#newsletter_list_forms").trigger( 'change' );

		filterFormsSelect();
		
		clearFieldsMappingValues();
	
	});
	
	$('#nf-builder').on('mouseover', 'select#newsletter_list', filterListsSelect );
	
	$('#nf-builder').on('mouseover', 'select#newsletter_list_forms', filterFormsSelect );
	
	$('#nf-builder').on('click', '.js-newsletter-list-update', function() {
		
		// First clean up the hidden field and the form selected option
		$('#ACfields_hidden_form_id').val( "" ).trigger( 'change' );
		$("#newsletter_list_forms option").prop("selected", false);
		$("#newsletter_list_forms").trigger( 'change' );
		$("#newsletter_list option").prop("selected", false);
		$("#newsletter_list").trigger( 'change' );
		
	} );
	
	
	
	$('#nf-builder').on('change', 'select#newsletter_list_forms', function() {
						
		//Set hidden value newsletter_list_forms
		var formOptionValue = this.value;
		var formOptionValueArray = formOptionValue.split('-');
		
		// The ID of the AC Form selected
		var acFormID = formOptionValueArray[0];
		
		$('#ACfields_hidden_form_id').val( acFormID ).trigger( 'change' );
		
	});	
});
